import java.io.*;
import java.util.*;

/*
 Si estenda (attenzione: non ridefinisca) un ADT MuPairADT.java per coppie modificabili, in un ADT, DiagMuPairADT.java per coppie diagonali, ovvero coppie (x,y) tali che x==y. In particolare:
 (a) Si mostri la definizione della nuova classe;
 (b) Si mostrino AF ed I della nuova rappresentazione;
 (c) Si provi la correttezza di I;
 */

/* (a) */

class DiagMuPairADT<A> extends MuPairADT<A,A>{
    public DiagMuPairADT (A x) throws invalidArgException{
        super(x,x);
    }
    public void setLeft(A x)throws invalidArgException{
                              //da aggiungere per uso effettivo
        super.setLeft(x); super.setRight(x);
    }
    public void setRight(A y){//da aggiungere per uso effettivo
        super.setLeft(y); super.setRight(y);
    }

}

/* (b) 
AF(c) = AF(super.c)
I(c) = true
 
Il nuovo tipo introduce un invarante sui valori coppia (x,y)\in[DiagMuPairADT<A>], ovvero:
        per tutti i v\in[DiagMuPairADT<A>], I(v)= v.getLeft()==v.getRight().
Provabile facilmente esaminando costruttori e modificatori di DiagMuPairADT.
*/

/* (c) da scrivere*/
class main{
    public static void main(String args[]) throws invalidArgException{
        MuPairADT <String,Integer> myAddress = new MuPairADT<String,Integer>("Pontecorvo",4);
        System.out.println("l'indirizzo è via " + myAddress.getLeft() + ", " + myAddress.getRight());
        myAddress.setRight(12);
        System.out.println("l'indirizzo è cambiato in " + myAddress.getLeft() + ", " + myAddress.getRight());
        
    }
}

/* (d)
 banale
*/
