import java.io.*;

/*
Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili. 
Si chiede di:
 (a) Ridefinirla in un un ADT, ImPairADT.java, per coppie non modificabili;
 (b) Fornire AF e I  di (della rappresentazione data in) PairADT.java;
 (c) Fornire un caso di uso di PairADT.java;
 (d) Provare la correttezza di I.

 public class Pair <A,B> {
   public final A left;
   public final B right;
   public Pair (A x, B y) {
      left = x;
      right = y;
   }
}
 */

/* (a) */
public class ImPairADT <A,B> {
    private final A left;//da nascondere
    private final B right;//da nascondere
    public ImPairADT (A x, B y) {
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
}

/* (b) 
Sia [ImPairADT<Ta,Tb>]={(x,y) | x\inTa, y\inTb, Ta\in[A], Tb\in[B]}, l'insieme dei valori
astratti definiti da ImPairADT<Ta,Tb>. Allora, per ogni valore concreto c esprimibile con
lo stato concreto definito dai fields della classe:
AF(c) = (c.left,c.right)
I(c) = true
*/

/* (c) */
class main{
    public static void main(String args[]){
        ImPairADT <Integer,String> myPlayCard = new ImPairADT<Integer,String>(3,"fiori");
        System.out.println("il valore della carta è " + myPlayCard.getLeft());
    }
}

/* (d) 
I(c) è true quindi è sempre verificato quindi la correttezza è banalmente provata
*/

/* (e)
Cosa dire se avessimo richiesto:
 I(c) = c.left!=NULL & c.right!=NULL
*/
