#include <stdio.h>
#include <stdlib.h>

/*
 Sia ${\tt c_{n}x^{n}+...+c_{0}}$, con ${\tt n\!\geq\!0, c_{n}\neq\!0, (i\in[0,n])\,c_{i}\!\in\![int]}$, un polinomio (a coefficienti interi) di grado n.
 Si fornisca in C un'implementazione per polinomi. In particolare, si mostri:\\
 (a) Lo stato della rappresentazione e relative dichiarazioni di tipo.\\
 (b) La funzione di astrazione, AF, e l'invariante di rappresentazione, I, relative ad (a).\\
 (c) Un caso di uso
 */


/* (a) */
struct polyStruct{
    int grado;
    int coeff[];
};
typedef struct polyStruct polyVal;
typedef polyVal * poly;
//un polynomio è un valore di tipo (concreto) poly.

/* b
AF(c) = c_{n}x^{n}+...+c_{0}, dove n=c->grado && (i\in[0..n])c_{i}=(c->coeff)[i]
I(c) = c!=null && c->grado>=0 && sizeof(c->coeff)==c.grado+1 && c->coeff[c->grado]!=0
 */

/* c */
int main(void){
    poly p = (poly)malloc(sizeof(int)*10);
    //il polinomio -5 x^{8} + 12
    p->grado = 8;//posizione 0
    p->coeff[0] = 12;//
    p->coeff[8] = -5;
    for(int i=1;i<=7;i++){
        p->coeff[i] = 0;
    }
    for(int i=8;i>0;--i){
        printf("%d x^%d +", (int)(p->coeff[i]), i);
    }
    printf("%d x^%d\n", (int)(p->coeff[0]), 0);
}

