import java.io.*;
import java.util.*;

interface DLinkSeq{
	public DLinkSeq pred();
	public DLinkSeq succ();
	public int val();
	public void valUpd(int v);
}

public class intMutSeq implements DLinkSeq {
/* ------------ rappresentazione interna ----------------- */	
	private intMutSeq Pred;
	private intMutSeq Succ;
	private int Val;
	public intMutSeq(intMutSeq p, int v){
		Pred = p;
		Val = v;
		if (p!=null){
			Succ = p.Succ;
			p.Succ = this;
			if (Succ!=null) Succ.Pred = this;
		}
	}	
/* ------------ Implementazione Metodi ------------------- */
	
	public intMutSeq pred(){
		return Pred;
	};
	public intMutSeq succ(){
		return Succ;
	};
	public int val(){
		return Val;
	}; 							
	public void valUpd(int v){
		Val = v;
	};
}
