import java.io.*;
import java.util.*;

/*
 Sia ${\tt c_{n}x^{n}+...+c_{0}}$, con ${\tt n\!\geq\!0, c_{n}\neq\!0, (i\in[0,n])\,c_{i}\!\in\![int]}$, un polinomio (a coefficienti interi) di grado n.
 Si fornisca in Java un'implementazione per polinomi. In particolare, si mostri:\\
 (a) Lo stato della rappresentazione e relative dichiarazioni di tipo.\\
 (b) La funzione di astrazione, AF, e l'invariante di rappresentazione, I, relative ad (a).\\
 (c) Un caso di uso
 */

/* (a) */
class invalidArgException extends Exception{
}

public class PolyJ{
    public int grado;
    public Vector<Integer> coeff;
    
    public PolyJ(int n) throws invalidArgException{
        if(n<0) throw new invalidArgException();
        grado = n;
        coeff = new Vector<Integer>(9);
    }
}
//un polynomio è un valore di tipo (concreto) PolyJ.

/* b
AF(c) = c_{n}x^{n}+...+c_{0}, dove n=c.grado && (i\in[0..n])c_{i}=c.coeff.get(i)
I(c) = c.coeff!=null && c.grado>=0 && c.coeff.size()==c.grado+1 && c.coeff.get(c.grado)!=0
 */

/* c */
class main{
    public static void main(String args[])throws invalidArgException{
    PolyJ p = new PolyJ(8);
    //il polinomio -5 x^{8} + 12
    p.coeff.add(0,12);//
    for(int i=1;i<=7;i++){
            p.coeff.add(i,0);
        }
    p.coeff.add(8,-5);
    for(int i=8;i>0;--i){
        System.out.print(p.coeff.get(i)+" x^"+i+" +");
    }
    System.out.println(p.coeff.get(0));
    }
}

